function SaveFileList(Sender) {

    var ini = new TIniFile(Script.GetPath + "projects.ini");
    var projroot = Lowercase(Script.ProjectSettings.SelectedProjectRoot);
    var c = Documents.Count;
    var counter = 0;

    ini.EraseSection(Script.ProjectSettings.SelectedProjectName);

    for (var i = 0; i < c; i++)
    {
        var doc = Documents.Tab[i];
        var fname = doc.FileName;

        if (Lowercase(copy(fname, 1, Length(projroot))) == projroot)
        {
            ini.WriteString(Script.ProjectSettings.SelectedProjectName, i, fname);
            counter++;
        }
    }

    alert("Saved " + _t(counter) + " files for project: " + Script.ProjectSettings.SelectedProjectName);
}

function OpenFileList(Sender) {

    var ini = new TIniFile(Script.GetPath + "projects.ini");
    var exists = ini.SectionExists(Script.ProjectSettings.SelectedProjectName);

    if(exists)
    {
        var SL = new TStringList;

        ini.ReadSection(Script.ProjectSettings.SelectedProjectName, SL);

        if(SL.Count > 0)
        {
            var fname = "";

            for (i = 0; i <= SL.Count-1; i++)
            {
                fname = ini.ReadString(Script.ProjectSettings.SelectedProjectName, SL[i], "");
                Documents.OpenDocument(fname);
            }

        } else {

            alert("There is no current file list for project: " + Script.ProjectSettings.SelectedProjectName);
        }

    } else {

        alert("There is no current file list for project: " + Script.ProjectSettings.SelectedProjectName);
    }
}

function CloseOtherProjects(Sender) {

  var projroot = Lowercase(Script.ProjectSettings.SelectedProjectRoot);
  var c = Documents.Count;

  for (var i = c-1; i >= 0; i--)
  {
    doc = Documents.Tab[i];
    var fname = doc.FileName;

    if ((Lowercase(copy(fname, 1, Length(projroot)))) != projroot)
    {
        doc.Close(False);
    }
  }

}

function OpenFileListCloseOtherProjects(Sender) {

    CloseOtherProjects(Sender);
    OpenFileList(Sender);

}

function ViewFileList(Sender){

    var ini = new TIniFile(Script.GetPath + "projects.ini");
    var exists = ini.SectionExists(Script.ProjectSettings.SelectedProjectName);

    if(exists)
    {
        var SL = new TStringList;

        ini.ReadSection(Script.ProjectSettings.SelectedProjectName, SL);

        if(SL.Count > 0)
        {
            var s = "There are " + _t(SL.Count) + " files for project: " + Script.ProjectSettings.SelectedProjectName + chr(13) + chr(10) + chr(13) + chr(10);
            var fname = "";

            for (i = 0; i <= SL.Count-1; i++)
            {
                fname = ini.ReadString(Script.ProjectSettings.SelectedProjectName, SL[i], "");
                s = s + fname + chr(13) + chr(10);
            }

              alert(s);

        } else {

            alert("There is no current file list for project: " + Script.ProjectSettings.SelectedProjectName);
        }

    } else {

        alert("There is no current file list for project: " + Script.ProjectSettings.SelectedProjectName);
    }
}

function RemoveFileList(Sender){

    if(Confirm("Are you sure that you wish to remove the file list for project: " + Script.ProjectSettings.SelectedProjectName + "?"))
    {
        var ini = new TIniFile(Script.GetPath + "projects.ini");
        ini.EraseSection(Script.ProjectSettings.SelectedProjectName);
    }

}

Script.RegisterAction("Current Project", "Save file list", "", &SaveFileList);
Script.RegisterAction("Current Project", "Open file list", "", &OpenFileList);
Script.RegisterAction("Current Project", "Close other projects", "", &CloseOtherProjects);
Script.RegisterAction("Current Project", "Close other projects and open file list", "", &OpenFileListCloseOtherProjects);
Script.RegisterAction("Current Project", "View file list", "", &ViewFileList);
Script.RegisterAction("Current Project", "Remove file list", "", &RemoveFileList);